/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package au.com.forward.runWST.maps;

import java.util.Comparator;
import au.com.forward.webstringtemplate.WebStringTemplate;

public class AttributeNameComparator implements Comparator {
		
		
		// sorts strings ignoring case
		// returns a negative integer, zero, or a positive integer
		// as the first argument is less than, equal to, or greater than the second
		public int compare(Object o1, Object o2) {
			if ((o1 == null) || (o2 == null)) {
				throw new IllegalArgumentException("Called AttributeNameComparator with null argument.\n");
			}
			if (! (o1 instanceof String)
				     && (o2 instanceof String)
					){
				throw new IllegalArgumentException("Called AttributeNameComparator with incorrect objects.\n"+
				  "Expected String found "+o1.getClass().getName()+" and "+o2.getClass().getName());
		  }
		 // sort .comment above attribute
		 String s1 = (String)o1;
		 String s2 = (String)o2;
		 boolean s1Comment = false;
		 boolean s2Comment = false;
		 if (s1.toLowerCase().endsWith(WebStringTemplate.WST_COMMENT_ENDING) ) {
			 s1Comment = true;
			 s1=s1.substring(0,s1.length()-WebStringTemplate.WST_COMMENT_ENDING.length());
		 }	
		 if (s2.toLowerCase().endsWith(WebStringTemplate.WST_COMMENT_ENDING) ) {
			 s2Comment = true;
			 s2=s2.substring(0,s2.length()-WebStringTemplate.WST_COMMENT_ENDING.length());
		 }	
		 int rtn = s1.compareToIgnoreCase(s2);
		 if ((!s1Comment && !s2Comment) || (rtn != 0) || ((s1Comment && s2Comment))) {
			 // either no comments or not equal ignoring comments or both have comments
			 // no change
		 } else {
		 // get here if only one .comment and prefix equal ignoring .comment
			 if (s1Comment) {  
				 // sort it to top				 
				 rtn = -1;
			 } else if (s2Comment) {
				 // sort it to top
				 rtn = +1;
			 }
		 }	 
		 return rtn;
	  }

  }		

