/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package au.com.forward.runWST.wstAttributeReader;
	/**
	 *  Description of the Class
	 *
	 *@author     matthew ford
	 *@created    November 26, 2003
	 */
	public class State {
		private int state = -2;
		private String name = "Invalid state";

    private State(String name, int state) {
			if ((name == null) || (name.trim().length()==0) ) {
				throw new IllegalArgumentException("State name cannot be null or blank.");
			}
			this.name = name;
			this.state = state;
		}
		
    public String toString() {
			return name;
		}
    
    public boolean gtEqInDl() {
			if (state >= IN_DL.state) {
				return true;
			} 
			return false;
		}
		
    public boolean equals(Object obj) {
			if (obj instanceof State) {
         return ((State)obj).state == this.state;
			} else {
				return false;
			}
		}
		
		public int hashCode() {
			return state;
		}
		
		public static final State ERROR = new State("ERROR",-1);
		public static final State NO_MAP_FOUND = new State("NO_MAP_FOUND",0);
		public static final State FINISHED = new State("FINISHED",1);
		public static final State IN_DL = new State("IN_DL",2);
		public static final State IN_DT = new State("IN_DT",3);
		public static final State IN_DD = new State("IN_DD",4);
		public static final State IN_OL = new State("IN_OL",5);
		public static final State IN_UL = new State("IN_UL",6);
		public static final State IN_LI = new State("IN_LI",7);
		public static final State END_DT = new State("END_DT",8);
		public static final State END_LI = new State("END_LI",9);

  }	

